#include <bits/stdc++.h>
using namespace std;

#define all(x) ::begin(x), ::end(x)
#define tsolve int t; cin >> t; while (t--) solve
#define sz(x) (int)::size(x)
using ll = long long;
using ld = long double;

void solve() {
    ll n, a, b;
    cin >> n >> a >> b;
    n--;
    vector<ll> d(n);

    ll sm = 0;
    for (ll& x : d) {
        cin >> x;
        sm += x;
    }
    if (sm - (a+b) < 0 || (sm - (a+b)) % 2 != 0) {
        cout << "NO\n";
        return;
    }
    
    vector<int> ind(n);
    iota(all(ind), 0);
    sort(all(ind), [&](int i, int j) { return d[i] > d[j]; });
    vector<int> rev(n);
    for (int i=0; i<n; i++) rev[ind[i]] = i;

    vector<pair<ll, ll>> ans;
    ans.emplace_back(0, 0);
    auto out = [&]() {
        cout << "YES\n";
        vector<pair<ll, ll>> steps(n);
        for (int i=0; i<n; i++) {
            ll x = ans[i+1].first - ans[i].first;
            ll y = ans[i+1].second - ans[i].second;
            cerr << d[rev[i]] << endl;
            steps[rev[i]] = {x, y};
        }
        ll x = 0, y = 0;
        for (auto [dx, dy] : steps) {
            x += dx, y += dy;
            cout << x << ' ' << dy << endl;
        }

        exit(0);
    };
    ll cur = 0;
    for (int i=0; i<n; i++) {
        cur += d[ind[i]];
        ll x = 0, y = 0;
        if (cur < a) x = cur, y = 0;
        else x = a, y = cur - a;

        if (abs(x-a) + abs(y-b) > sm - cur) {
            cur -= d[ind[i]];
            tie(x, y) = ans.back();
            ll dist = abs(x-a) + abs(y-b);
            ll left = sm - cur;
            ll detour = (left - dist) / 2;
            cerr << dist << ' ' << left << ' ' << detour << ' ' << d[ind[i]] << endl;
            /*if (d[ind[i]] > left - detour) {
                cout << "NO\n";
                return;
            }*/
            cur = 0;
            while (i < n) {
                cur += d[ind[i]];
                if (cur <= detour) ans.emplace_back(x + cur, y);
                else if (cur <= left - detour) ans.emplace_back(x + detour, y + cur - detour);
                else ans.emplace_back(x + detour - (cur - (left - detour)), b);
                i++;
            }
            out();
        }
        ans.emplace_back(x, y);
    }
    
    cout << "NO\n";
}

int main() {
    cout.tie(0)->sync_with_stdio(false);
    cout << setprecision(16);
    solve();
}
