#include <bits/stdc++.h>
using namespace std;

#define all(x) ::begin(x), ::end(x)
#define tsolve int t; cin >> t; while (t--) solve
#define sz(x) (int)::size(x)
using ll = long long;
using ld = long double;

void solve() {
    ll n, a, b;
    cin >> n >> a >> b;
    n--;
    vector<ll> d(n);

    ll sm = 0;
    for (ll& x : d) {
        cin >> x;
        sm += x;
    }
    if (sm - (a+b) < 0 || (sm - (a+b)) % 2 != 0) {
        cout << "NO\n";
        return;
    }
    
    vector<int> ind(n);
    iota(all(ind), 0);
    sort(all(ind), [&](int i, int j) { return d[i] < d[j]; });

    ll detour = sm - (a+b);
    detour /= 2;
    cerr << detour << endl;

    ll cur = 0;
    vector<pair<ll, ll>> ans;
    ans.emplace_back(0, 0);
    auto out = [&]() {
        cout << "YES\n";
        vector<pair<ll, ll>> steps(n);
        for (int i=0; i<n; i++) {
            ll x = ans[i+1].first - ans[i].first;
            ll y = ans[i+1].second - ans[i].second;
            steps[ind[i]] = {x, y};
        }
        ll x = 0, y = 0;
        for (auto [dx, dy] : steps) {
            x += dx, y += dy;
            cout << x << ' ' << dy << endl;
        }

        exit(0);
    };
    for (ll i : ind) {
        cur += d[i];
        if (detour <= cur && cur <= detour + b) {
            cur = 0;
            for (ll e : ind) {
                cur += d[e];
                cerr << "?: " << cur << ' ' << detour << endl;
                if (cur <= detour) ans.emplace_back(-cur, 0);
                else if (cur <= detour + b) ans.emplace_back(-detour, cur - detour);
                else ans.emplace_back(cur - detour - b, b);
                cerr << ans.back().first << ' ' << ans.back().second << endl;
            }
            out();
        }
        
        if (detour + b <= cur && cur <= detour + a + b) {
            cur = 0;
            for (ll e : d) {
                cur += e;
                if (cur <= detour + b) cout << 0 << ' ' << cur << '\n';
                else if (cur <= detour + a + b) cout << cur - detour - b << ' ' << detour + b << '\n';
                else cout << a << ' ' << cur - detour - b - a << '\n';
            }
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    cout.tie(0)->sync_with_stdio(false);
    cout << setprecision(16);
    solve();
}
